#!/usr/bin/python

"""
pisa_hol = []
file_hol = open("/Users/n_skalis/iCode/Xcode/iSIM/src/_debug/_dats/instantaneous_hol_weights.dat", "r")
data_hol = []
for line_hol in file_hol :
	data_hol = line_hol.split('\t')
	if len(data_hol) == 3 :
		time = int(data_hol[0].strip())
		port = int(data_hol[1].strip())
		cells = [float(x) for x in data_hol[2].strip().split() if x != '0.0']
		pisa_hol.append(tuple([time, port, cells]))
	else :
		print "ERROR : Input data are NOT formated properly !"

pisa_out = []
file_out = open("/Users/n_skalis/iCode/Xcode/iSIM/src/_debug/_dats/instantaneous_out_weights.dat", "r")
data_out = []
for line_out in file_out :
	data_out = line_out.split('\t')
	if len(data_out) == 3 :
		time = int(data_out[0].strip())
		port = int(data_out[1].strip())
		cells = [float(x) for x in data_out[2].strip().split() if x != '0.0']
		pisa_out.append(tuple([time, port, cells]))
	else :
		print "ERROR : Input data are NOT formated properly !"

assert (len(pisa_hol) == len(pisa_out)), "ERROR : HoL and Out lists are NOT of equal sizes !"

pisa = {}
cells = []
for i in range(0, len(pisa_hol)) :
	assert (pisa_hol[i][0] == pisa_out[i][0]), "ERROR : You calculated data based on different timestamps !"
	assert (pisa_hol[i][1] == pisa_out[i][1]), "ERROR : You calculated data based on different ports !"
	time = pisa_hol[i][0]
	port = pisa_hol[i][1]
	hol_cells = pisa_hol[i][2]
	hol_items = len(pisa_hol[i][2])
	out_cells = pisa_out[i][2]
	out_items = len(pisa_out[i][2])
	if pisa.has_key(port) :
		if (sum(pisa[port][1]) > sum(hol_cells)) and (sum(pisa[port][3]) < sum(out_cells)) :
			pisa[port] = [hol_items, hol_cells, out_items, out_cells]
	else :
		pisa[port] = [hol_items, hol_cells, out_items, out_cells]

file_pisa = open("/Users/n_skalis/iCode/Xcode/iSIM/src/_debug/_dats/(port)-(hol_items)-(hol_weights)-(out_items)-(out_weights).dat", "w")
dictionary_keys = pisa.keys()
dictionary_item = ""
for key in dictionary_keys :
	file_pisa.write( str(key) + "\t" )
	dictionary_hol_item = ""
	for x in pisa[key][1] :
		dictionary_hol_item += str(round(x,3)) + " "
	file_pisa.write( str(pisa[key][0]) + "\t" + dictionary_hol_item + "\t")
	dictionary_out_item = ""
	for x in pisa[key][3] :
		dictionary_out_item += str(round(x,3)) + " "
	file_pisa.write( str(pisa[key][2]) + "\t" + dictionary_out_item + "\n")
file_pisa.close()
"""

slackness_hol = []
slackness_file = open("/Users/n_skalis/iCode/Xcode/iSIM/src/_debug/_ports/slackness_hol.dat", "r")
slackness_data = []
for slackness_line in slackness_file :
	slackness_data = slackness_line.split('\t')
	if len(slackness_data) == 4 :
		time = int(slackness_data[0].strip())
		port = int(slackness_data[1].strip())
		no = int(slackness_data[2].strip())
		occ = int(slackness_data[3].strip())
		slackness_hol.append(tuple([time, port, no, occ]))
	else :
		print "ERROR : Input data are NOT formated properly !"
slackness_file.close()
	
slackness = {}
for i in range(0, len(slackness_hol)) :
	time = slackness_hol[i][0]
	port = slackness_hol[i][1]
	no = slackness_hol[i][2]
	occ = slackness_hol[i][3]
	B = no + occ
	if slackness.has_key(port) :
		if B > slackness[port][0] :
			slackness[port] = [ B ]
	else :
		slackness[port] = [ B ]
print slackness
index = max(slackness.iterkeys(), key=lambda k: slackness[k])
print "B(" + str(index) + ") = " + str(slackness[index])